//MocIcon. see README for help.
//compile with gcc -Wall -g mocicon.c -o mocicon `pkg-config --cflags --libs gtk+-2.0`

#include <gtk/gtk.h> 
static void play(GtkWidget *w);
static void stop(GtkWidget *w);
static void start(GtkWidget *w);
static void next(GtkWidget *w);
static void prev(GtkWidget *w);
gboolean button_press_cb(GtkStatusIcon *icon, GdkEventButton *ev, gpointer user_data) 
{  
    GtkWidget *menu, *quit_item, *play_item, *stop_item, *start_item, *next_item, *prev_item; 

    if(ev->button == 1) 
    { 
     	 menu = gtk_menu_new(); 

// Create Items
	 start_item = gtk_image_menu_item_new_with_label("Start Server");
	 stop_item  = gtk_image_menu_item_new_with_label("Stop Server");
	 next_item  = gtk_image_menu_item_new_with_label("Next");
	 prev_item  = gtk_image_menu_item_new_with_label("Previous");
	 play_item  = gtk_image_menu_item_new_with_label("Play/Pause");
	 quit_item  = gtk_image_menu_item_new_with_label("Quit");
	          
// Signals
	g_signal_connect(quit_item, "activate", G_CALLBACK(gtk_main_quit), NULL);
	g_signal_connect(play_item, "activate", G_CALLBACK(play), NULL);
	g_signal_connect(start_item, "activate", G_CALLBACK(start), NULL);
	g_signal_connect(stop_item, "activate", G_CALLBACK(stop), NULL);
	g_signal_connect(prev_item, "activate", G_CALLBACK(prev), NULL);
	g_signal_connect(next_item, "activate", G_CALLBACK(next), NULL);

	 
	 // append items
        
  	 gtk_menu_shell_append(GTK_MENU_SHELL(menu), play_item); 
	 gtk_menu_shell_append(GTK_MENU_SHELL(menu), stop_item); 
	 gtk_menu_shell_append(GTK_MENU_SHELL(menu), start_item); 	
	 gtk_menu_shell_append(GTK_MENU_SHELL(menu), next_item); 	
	 gtk_menu_shell_append(GTK_MENU_SHELL(menu), prev_item); 	
	 gtk_menu_shell_append(GTK_MENU_SHELL(menu), quit_item); 
 	 // show widgets
        gtk_widget_show_all(menu);
     // Popup the menu 
         gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL, ev->button, ev->time); 

    } 
    return FALSE; 
} 

//this whole section really should just be one function with an if/then statement instead of a dozen different little functions

//play or pause
void play(GtkWidget *w) {
g_spawn_command_line_async("mocp -G", NULL);
}

//stop server
void stop(GtkWidget *w) {
g_spawn_command_line_async("mocp -x", NULL);
}

//start server
void start(GtkWidget *w) {
g_spawn_command_line_async("mocp --play", NULL);
}

//next song
void next(GtkWidget *w) {
g_spawn_command_line_async("mocp --next", NULL);
}
//previous song
void prev(GtkWidget *w) {
g_spawn_command_line_async("mocp --previous", NULL);
}

gint main(gint argc, gchar **argv) 
{ 
    GtkStatusIcon *icon; 

    gtk_init(&argc, &argv); 
    icon = gtk_status_icon_new_from_stock(GTK_STOCK_MEDIA_PLAY); 
    g_signal_connect(icon,"button-press-event", G_CALLBACK(button_press_cb), NULL); 
    gtk_main(); 

    return 0; 
}
